#ifndef _FONT_H_
#define _FONT_H_

#include "sc.h"

#define POS		0x0
#define CIR		0x1
#define NEG		0x2

/* start index, length */
unsigned char code character_index_table[] = {
	0, 0, 		// Space
	1, 2, 		// !
	3, 2,
	5, 4,
	9, 3,
	12, 3,
	15, 4,
	19, 2,
	21, 1,
	22, 1,
	23, 3,
	26, 2,
	28, 2,
	30, 1,
	31, 1,
	32, 1,
	33, 1, 		// 0
	34, 2,
	36, 3,
	39, 3,
	42, 3,
	45, 3,
	48, 2,
	50, 2,
	52, 2,
	54, 2, 		// 9
	56, 2,
	58, 3,
	61, 2,
	63, 2,
	65, 2,
	67, 3,	
	70, 3, 		// @
	73, 3, 		// A
	76, 6, 		// B
	82, 1,		// C
	83, 4, 		// D
	87, 4, 		// E
	91, 3, 		// F
	94, 3, 		// G
	97, 3, 		// H
	100 ,3, 	// I
	103, 2,		// J
	105, 3,   // K
	108, 2, 	// L
	110, 4, 	// M
	114, 3, 	// N
	117, 1, 	// O
	118, 4, 	// P
	122, 2, 	// Q
	124, 5, 	// R
	129, 2, 	// S
	131, 2, 	// T
	133, 3, 	// U
	136, 2,   // V
	138, 4, 	// W
	142, 2, 	// X
	144, 3, 	// Y
	147, 3, 	// Z
	150, 3, 	// [
	153, 1, 	// Backslash
	154, 3, 	// ]
	157, 2, 	// ^
	159, 1, 	// _
	160, 1, 	// '
	161, 2, 	// a
	163, 2, 	// b
	165, 1, 	// c
	166, 2, 	// d
	168, 2, 	// e
	170, 3, 	// f
	173, 3, 	// g
	176, 3, 	// h
	179, 2, 	// i
	181, 3, 	// j
	184, 3, 	// k
	187, 1, 	// l
	188, 5, 	// m
	193, 3, 	// n
	196, 1, 	// o
	197, 2, 	// p
	199, 2, 	// q
	201, 2, 	// r
	203, 2, 	// s
	205, 3, 	// t
	208, 3, 	// u
	211, 2, 	// v
	213, 4, 	// w
	217, 2, 	// x
	219, 3, 	// y
	222, 3, 	// z
	225, 4, 	// {
	229, 1, 	// |
	230, 4, 	// }
	234, 2, 	// ~
	236, 3, 	// Del
};

/* x center, y center, x size, y size, shape, blank segment */
unsigned char code character_shape_table[] = {
	0, 0, 0, 0, POS, 0xFF, 			// Space
	1, 7, 0, 22, POS, 0xCC, 		// !
	1, 19, 2, 2, CIR, 0xFF,
	0, 4, 0, 12, POS, 0xCC, 		// "
	6, 4, 0, 12, POS, 0xCC,
	3, 8, 3, 24, POS, 0xCC, 		// #
	8, 8, 3, 24, POS, 0xCC,
	5, 11, 15, 0, POS, 0xCC,
	6, 8, 15, 0, POS, 0xCC,
	5, 14, 10, 8, CIR, 0xf9, 		// $
	5, 6, 10, 8, CIR, 0x9F,
	5, 10, 0, 36, POS, 0xCC,
	3, 3, 6, 6, CIR, 0xff, 			// %
	9, 17, 6, 6, CIR, 0xff,
	6, 10, 18, 30, POS, 0xCC,
	4, 5, 8, 10, CIR, 0x7F, 		// &
	4, 15, 8, 10, CIR, 0x87,
	4, 12, 16, 16, CIR, 0x60,
	6, 14, 15, 18, NEG, 0xCC,
	3, 1, 2, 2, CIR, 0xFF, 			// `
	0, 1, 8, 12, CIR, 0x60,
	4, 10, 8, 20, CIR, 0x87, 		// (
	0, 10, 8, 20, CIR, 0x78, 		// )	
	6, 10, 18, 00, POS, 0xCC, 	// *
	6, 10, 12, 18, POS, 0xCC,
	6, 10, 12, 18, NEG, 0xCC,
	6, 10, 18, 0, POS, 0xCC, 		// +
	6, 10, 0, 18, POS, 0xCC,
	3, 19, 2, 2, CIR, 0xFF, 		// ,
	0, 19, 8, 12, CIR, 0x60,
	6, 10, 18, 0, POS, 0xCC, 		// -
	1, 19, 2, 2, CIR, 0xFF, 		// .
	6, 10, 18, 30, POS, 0xCC, 	// /
	6, 10, 12, 20, CIR, 0xFF, 	// 0
	7, 10, 0, 30, POS, 0xCC, 		// 1
	5, 2, 6, 6, POS, 0xCC,
	6, 6, 12, 12, CIR, 0x7E,		// 2
	6, 20, 12, 16, CIR, 0x06,
	6, 20, 18, 0, POS, 0xCC,
	6, 14, 12, 12, CIR, 0xF8,		// 3
	6, 0, 10, 16, CIR, 0x60,
	6, 0, 15, 0, POS, 0xCC,
	8, 10, 0, 30, POS, 0xCC,		// 4
	6, 14, 18, 0, POS, 0xCC,
	4, 7, 12, 22, POS, 0xCC,
	6, 14, 12, 12, CIR, 0xFC, 	// 5
	3, 5, 03, 15, POS, 0xCC,
	8, 0, 12, 0, POS, 0xCC,
	6, 14, 12, 12, CIR, 0xFF, 	// 6
	5, 5, 9, 15, POS, 0xCC,
	6, 10, 18, 30, POS, 0xCC, 	// 7
	6, 0, 18, 0, POS, 0xCC,
	6, 14, 12, 12, CIR, 0xFF, 	// 8
	6, 4, 8, 8, CIR, 0xFF,
	6, 6, 12, 12, CIR, 0xFF, 		// 9
	7, 15, 9, 15, POS, 0xCC,
	1, 14, 2, 2, CIR, 0xFF, 		// :
	1, 6, 2, 2, CIR, 0xFF,
	3, 6, 2, 02, CIR, 0xFF, 		// ;
	3, 14, 2, 02, CIR, 0xFF,
	0, 14, 8, 12, CIR, 0x60,
	6, 6, 18, 12, POS, 0xCC, 		// <
	6, 14, 18, 12, NEG, 0xCC,
	6, 7, 18, 0, POS, 0xCC, 		// =
	6, 13, 18, 0, POS, 0xCC,
	6, 6, 18, 12, NEG, 0xCC, 		// >
	6, 14, 18, 12, POS, 0xCC,
	5, 6, 10, 10, CIR, 0x7E, 		// ?
	5, 13, 4, 4, CIR, 0x9F,
	5, 19, 2, 2, CIR, 0xFF,
	3, 10, 6, 10, CIR, 0xFF, 		// @
	3, 10, 14, 20, CIR, 0xDF,
	8, 10, 4, 4, CIR, 0xE1,	
	3, 10, 9, 30, POS, 0xCC, 		// A
	9, 10, 9, 30, NEG, 0xCC,
	6, 12, 9, 0, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// B
	4, 20, 12, 0, POS, 0xCC,
	4, 10, 12, 0, POS, 0xCC,
	4, 0, 12, 0, POS, 0xCC,
	8, 15, 10, 10, CIR, 0x78,
	8, 5, 10, 10, CIR, 0x78,
	7, 10, 14, 20, CIR, 0xCF, 	// C
	0, 10, 0, 30, POS, 0xCC, 		// D
	2, 20, 6, 0, POS, 0xCC,
	2, 0, 6, 0, POS, 0xCC,
	4, 10, 16, 20, CIR, 0x78,
	0, 10, 0, 30, POS, 0xCC, 		// E
	6, 20, 18, 0, POS, 0xCC,
	4, 10, 12, 0, POS, 0xCC,
	6, 0, 18, 0, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// F
	4, 10, 12, 0, POS, 0xCC,
	6, 0, 18, 0, POS, 0xCC,
	7,10, 14, 20, CIR, 0xCF, 		// G
	11, 15, 0, 9, POS, 0xCC,
	9, 12, 6, 0, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// H
	12, 10, 0, 30, POS, 0xCC,
	6, 10, 18, 0, POS, 0xCC,
	2, 10, 0, 30, POS, 0xCC, 		// I
	2, 20, 9, 0, POS, 0xCC,
	2, 0, 9, 0, POS, 0xCC,
	12, 7, 0, 22, POS, 0xCC, 		// J
	6, 14, 12, 12, CIR, 0xE1,
	0, 10, 0, 30, POS, 0xCC, 		// K
	6, 15, 18, 15, NEG, 0xCC,
	6, 5, 18, 15, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// L
	6, 20, 18, 0, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// M
	12, 10, 0, 30, POS, 0xCC,
	3, 5, 9, 15, NEG, 0xCC,
	9, 5, 9, 15, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// N
	12, 10, 0, 30, POS, 0xCC,
	6, 10, 18, 30, NEG, 0xCC,
	6, 10, 12, 20, CIR, 0xFF, 	// O
	0, 10, 0, 30, POS, 0xCC, 		// P
	4, 10, 12, 0, POS, 0xCC,
	4, 0, 12, 0, POS, 0xCC,
	8, 5, 10, 10, CIR, 0x78,
	6, 10, 12, 20, CIR, 0xFF, 	// Q
	10, 17, 6, 9, NEG, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// R
	4, 10, 12, 00, POS, 0xCC,
	4, 0, 12, 0, POS, 0xCC,
	8, 5, 10, 10, CIR, 0x78,
	9, 15, 9, 15, NEG, 0xCC,
	6, 15, 12, 10, CIR, 0xF9, 	// S
	6, 5, 12, 10, CIR, 0x9F,
	6, 10, 0, 30, POS, 0xCC, 		// T
	6, 0, 18, 0, POS, 0xCC,
	0, 7, 0, 22, POS, 0xCC, 		// U
	12, 7, 0, 22, POS, 0xCC,
	6, 14, 12, 12, CIR, 0xE1,
	3, 10, 9, 30, NEG, 0xCC,		// V
	9, 10, 9, 30, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// W
	12, 10, 0, 30, POS, 0xCC,
	3, 15, 9, 15, POS, 0xCC,
	9, 15, 9, 15, NEG, 0xCC,
	6, 10, 18, 30, NEG, 0xCC, 	// X
	6, 10, 18, 30, POS, 0xCC,
	6, 15, 0, 15, POS, 0xCC, 		// Y
	3, 5, 9, 15, NEG, 0xCC,
	9, 5, 9, 15, POS, 0xCC,
	6, 10, 18, 30, POS, 0xCC, 	// Z
	6, 20, 18, 0, POS, 0xCC,
	6, 0, 18, 0, POS, 0xCC,
	0, 10, 0, 30, POS, 0xCC, 		// [
	2, 20, 6, 0, POS, 0xCC,
	2, 0, 6, 0, POS, 0xCC,
	6, 10, 18, 30, NEG, 0xCC, 	// '\' 
	4, 10, 0, 30, POS, 0xCC, 		// ]
	2, 20, 6, 0, POS, 0xCC,
	2, 0, 6, 0, POS, 0xCC,
	3, 7, 9, 9, POS, 0xCC, 			// ^
	9, 7, 9, 9, NEG, 0xCC,
	6, 20, 18, 0, POS, 0xCC, 		// _
	2, 4, 6, 12, NEG, 0xCC, 		// '
	5, 14, 10, 12, CIR, 0xFF, 	// a
	10, 14, 0, 18, POS, 0xCC,
	5, 14, 10, 12, CIR, 0xFF, 	// b
	0, 10, 0, 30, POS, 0xCC,
	5, 14, 10, 12, CIR, 0xCF, 	// c
	5, 14, 10, 12, CIR, 0xFF,		// d
	10, 10, 0, 30, POS, 0xCC,
	5, 14, 10, 12, CIR, 0xDF, 	// e
	5, 14, 15, 0, POS, 0xCC,
	7, 4, 6, 8, CIR, 0x1E, 			// f
	4, 10, 12, 0, POS, 0xCC,
	4, 12, 0, 24, POS, 0xCC,
	5, 14, 10, 12, CIR, 0xFF, 	// g
	10, 14, 00, 18, POS, 0xCC,
	5, 20, 10, 12, CIR, 0xE0,
	4, 12, 8, 8, CIR, 0x1E, 		// h
	0, 10, 0, 30, POS, 0xCC,
	8, 16, 0, 12, POS, 0xCC,
	1, 4, 2, 2, CIR, 0xFF, 			// i
	1, 14, 0, 18, POS, 0xCC,
	6, 4, 2, 2, CIR, 0xFF, 			// j
	6, 14, 0, 18, POS, 0xCC,
	3, 20, 6, 8, CIR, 0xE0,
	0, 10, 0, 30, POS, 0xCC, 		// k
	4, 12, 12, 12, POS, 0xCC,
	4, 17, 9, 9, NEG, 0xCC,
	1, 10, 0, 30, POS, 0xCC, 		// l
	0, 14, 0, 18, POS, 0xCC, 		// m
	4, 12, 8, 8, CIR, 0x1E,
	8, 16, 0, 12, POS, 0xCC,
	12, 12, 8, 8, CIR, 0x1E,
	16, 16, 0, 12, POS, 0xCC,
	0, 14, 0, 18, POS, 0xCC, 		// n
	4, 12, 8, 8, CIR, 0x1E,
	8, 16, 0, 12, POS, 0xCC,
	5, 14, 10,12, CIR, 0xFF, 		// o
	5, 14, 10, 12, CIR, 0xFF, 	// p
	0, 17, 0, 24, POS, 0xCC,
	5, 14, 10, 12, CIR, 0xFF, 	// q
	10, 17, 0, 24, POS, 0xCC,
	0, 14, 0, 18, POS, 0xCC, 		// r
	5, 14, 10, 12, CIR, 0x0E,
	4, 11, 8, 6, CIR, 0x9F, 		// s
	4, 17, 8, 6, CIR, 0xF9,
	8, 16, 8, 8, CIR, 0x81, 		// t
	4, 8, 12, 0, POS, 0xCC,
	4, 10, 0, 18, POS, 0xCC,
	8, 14, 0, 18, POS, 0xCC, 		// u
	4, 16, 8, 8, CIR, 0xE1,
	0, 12, 0, 12, POS, 0xCC,
	2, 14, 6, 18, NEG, 0xCC, 		// v
	6, 14, 6, 18, POS, 0xCC,
	2, 14, 6, 18, NEG, 0xCC, 		// w
	6, 14, 6, 18, POS, 0xCC,
	10, 14, 6, 18, NEG, 0xCC,
	14, 14, 6, 18, POS, 0xCC,
	4, 14, 12, 18, NEG, 0xCC, 	// x
	4, 14, 12, 18, POS, 0xCC,
	2, 14, 6, 18, NEG, 0xCC, 		// y
	6, 14, 6, 18, POS, 0xCC,
	1, 20, 6, 8, CIR, 0x60,
	4, 20, 12, 0, POS, 0xCC, 		// z
	4, 8, 12, 0, POS, 0xCC,
	4, 14, 12, 18, POS, 0xCC,
	8, 14, 8, 12, CIR, 0x81, 		// {
	0, 14, 8, 8, CIR, 0x18,
	0, 6, 8, 8, CIR, 0x60,
	8, 6, 8, 12, CIR, 0x06,
	1, 10, 0, 36, POS, 0xCC, 		// |
	0, 14, 8, 12, CIR, 0x60, 		// }
	8, 14, 8, 8, CIR, 0x06,
	8, 6, 8, 8, CIR, 0x81,
	0, 6, 8, 12, CIR, 0x18,
	3, 8, 6, 4, CIR, 0x1E, 			// ~
	9, 8, 6, 4, CIR, 0xE1,
	3, 5, 9, 15, POS, 0xCC, 			// Del
	6, 10, 18, 30, POS, 0xCC,
	9, 15, 9, 15, POS, 0xCC
};
#endif
